<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `&#x2F;nix&#x2F;store&#x2F;v9jmyrpcwymx5d6inidy85x2ljzgm935-vendored-sources&#x2F;backtrace-0.3.64&#x2F;src&#x2F;symbolize&#x2F;gimli.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>gimli.rs - source</title><link rel="stylesheet" type="text/css" href="../../../normalize.css"><link rel="stylesheet" type="text/css" href="../../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../../light.css"  id="themeStyle"><link rel="stylesheet" type="text/css" href="../../../dark.css" disabled ><link rel="stylesheet" type="text/css" href="../../../ayu.css" disabled ><script id="default-settings" ></script><script src="../../../storage.js"></script><script src="../../../crates.js"></script><noscript><link rel="stylesheet" href="../../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../../favicon.svg"><style type="text/css">#crate-search{background-image:url("../../../down-arrow.svg");}</style></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu" role="button">&#9776;</div><a href='../../../backtrace/index.html'><div class='logo-container rust-logo'><img src='../../../rust-logo.png' alt='logo'></div></a></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!" aria-haspopup="menu" title="themes"><img width="18" height="18" alt="Pick another theme!" src="../../../brush.svg"></button><div id="theme-choices" role="menu"></div></div><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><button type="button" id="help-button" title="help">?</button><a id="settings-menu" href="../../../settings.html" title="settings"><img width="18" height="18" alt="Change settings" src="../../../wheel.svg"></a></div></form></nav><section id="main" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">  1</span>
<span id="2">  2</span>
<span id="3">  3</span>
<span id="4">  4</span>
<span id="5">  5</span>
<span id="6">  6</span>
<span id="7">  7</span>
<span id="8">  8</span>
<span id="9">  9</span>
<span id="10"> 10</span>
<span id="11"> 11</span>
<span id="12"> 12</span>
<span id="13"> 13</span>
<span id="14"> 14</span>
<span id="15"> 15</span>
<span id="16"> 16</span>
<span id="17"> 17</span>
<span id="18"> 18</span>
<span id="19"> 19</span>
<span id="20"> 20</span>
<span id="21"> 21</span>
<span id="22"> 22</span>
<span id="23"> 23</span>
<span id="24"> 24</span>
<span id="25"> 25</span>
<span id="26"> 26</span>
<span id="27"> 27</span>
<span id="28"> 28</span>
<span id="29"> 29</span>
<span id="30"> 30</span>
<span id="31"> 31</span>
<span id="32"> 32</span>
<span id="33"> 33</span>
<span id="34"> 34</span>
<span id="35"> 35</span>
<span id="36"> 36</span>
<span id="37"> 37</span>
<span id="38"> 38</span>
<span id="39"> 39</span>
<span id="40"> 40</span>
<span id="41"> 41</span>
<span id="42"> 42</span>
<span id="43"> 43</span>
<span id="44"> 44</span>
<span id="45"> 45</span>
<span id="46"> 46</span>
<span id="47"> 47</span>
<span id="48"> 48</span>
<span id="49"> 49</span>
<span id="50"> 50</span>
<span id="51"> 51</span>
<span id="52"> 52</span>
<span id="53"> 53</span>
<span id="54"> 54</span>
<span id="55"> 55</span>
<span id="56"> 56</span>
<span id="57"> 57</span>
<span id="58"> 58</span>
<span id="59"> 59</span>
<span id="60"> 60</span>
<span id="61"> 61</span>
<span id="62"> 62</span>
<span id="63"> 63</span>
<span id="64"> 64</span>
<span id="65"> 65</span>
<span id="66"> 66</span>
<span id="67"> 67</span>
<span id="68"> 68</span>
<span id="69"> 69</span>
<span id="70"> 70</span>
<span id="71"> 71</span>
<span id="72"> 72</span>
<span id="73"> 73</span>
<span id="74"> 74</span>
<span id="75"> 75</span>
<span id="76"> 76</span>
<span id="77"> 77</span>
<span id="78"> 78</span>
<span id="79"> 79</span>
<span id="80"> 80</span>
<span id="81"> 81</span>
<span id="82"> 82</span>
<span id="83"> 83</span>
<span id="84"> 84</span>
<span id="85"> 85</span>
<span id="86"> 86</span>
<span id="87"> 87</span>
<span id="88"> 88</span>
<span id="89"> 89</span>
<span id="90"> 90</span>
<span id="91"> 91</span>
<span id="92"> 92</span>
<span id="93"> 93</span>
<span id="94"> 94</span>
<span id="95"> 95</span>
<span id="96"> 96</span>
<span id="97"> 97</span>
<span id="98"> 98</span>
<span id="99"> 99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
<span id="219">219</span>
<span id="220">220</span>
<span id="221">221</span>
<span id="222">222</span>
<span id="223">223</span>
<span id="224">224</span>
<span id="225">225</span>
<span id="226">226</span>
<span id="227">227</span>
<span id="228">228</span>
<span id="229">229</span>
<span id="230">230</span>
<span id="231">231</span>
<span id="232">232</span>
<span id="233">233</span>
<span id="234">234</span>
<span id="235">235</span>
<span id="236">236</span>
<span id="237">237</span>
<span id="238">238</span>
<span id="239">239</span>
<span id="240">240</span>
<span id="241">241</span>
<span id="242">242</span>
<span id="243">243</span>
<span id="244">244</span>
<span id="245">245</span>
<span id="246">246</span>
<span id="247">247</span>
<span id="248">248</span>
<span id="249">249</span>
<span id="250">250</span>
<span id="251">251</span>
<span id="252">252</span>
<span id="253">253</span>
<span id="254">254</span>
<span id="255">255</span>
<span id="256">256</span>
<span id="257">257</span>
<span id="258">258</span>
<span id="259">259</span>
<span id="260">260</span>
<span id="261">261</span>
<span id="262">262</span>
<span id="263">263</span>
<span id="264">264</span>
<span id="265">265</span>
<span id="266">266</span>
<span id="267">267</span>
<span id="268">268</span>
<span id="269">269</span>
<span id="270">270</span>
<span id="271">271</span>
<span id="272">272</span>
<span id="273">273</span>
<span id="274">274</span>
<span id="275">275</span>
<span id="276">276</span>
<span id="277">277</span>
<span id="278">278</span>
<span id="279">279</span>
<span id="280">280</span>
<span id="281">281</span>
<span id="282">282</span>
<span id="283">283</span>
<span id="284">284</span>
<span id="285">285</span>
<span id="286">286</span>
<span id="287">287</span>
<span id="288">288</span>
<span id="289">289</span>
<span id="290">290</span>
<span id="291">291</span>
<span id="292">292</span>
<span id="293">293</span>
<span id="294">294</span>
<span id="295">295</span>
<span id="296">296</span>
<span id="297">297</span>
<span id="298">298</span>
<span id="299">299</span>
<span id="300">300</span>
<span id="301">301</span>
<span id="302">302</span>
<span id="303">303</span>
<span id="304">304</span>
<span id="305">305</span>
<span id="306">306</span>
<span id="307">307</span>
<span id="308">308</span>
<span id="309">309</span>
<span id="310">310</span>
<span id="311">311</span>
<span id="312">312</span>
<span id="313">313</span>
<span id="314">314</span>
<span id="315">315</span>
<span id="316">316</span>
<span id="317">317</span>
<span id="318">318</span>
<span id="319">319</span>
<span id="320">320</span>
<span id="321">321</span>
<span id="322">322</span>
<span id="323">323</span>
<span id="324">324</span>
<span id="325">325</span>
<span id="326">326</span>
<span id="327">327</span>
<span id="328">328</span>
<span id="329">329</span>
<span id="330">330</span>
<span id="331">331</span>
<span id="332">332</span>
<span id="333">333</span>
<span id="334">334</span>
<span id="335">335</span>
<span id="336">336</span>
<span id="337">337</span>
<span id="338">338</span>
<span id="339">339</span>
<span id="340">340</span>
<span id="341">341</span>
<span id="342">342</span>
<span id="343">343</span>
<span id="344">344</span>
<span id="345">345</span>
<span id="346">346</span>
<span id="347">347</span>
<span id="348">348</span>
<span id="349">349</span>
<span id="350">350</span>
<span id="351">351</span>
<span id="352">352</span>
<span id="353">353</span>
<span id="354">354</span>
<span id="355">355</span>
<span id="356">356</span>
<span id="357">357</span>
<span id="358">358</span>
<span id="359">359</span>
<span id="360">360</span>
<span id="361">361</span>
<span id="362">362</span>
<span id="363">363</span>
<span id="364">364</span>
<span id="365">365</span>
<span id="366">366</span>
<span id="367">367</span>
<span id="368">368</span>
<span id="369">369</span>
<span id="370">370</span>
<span id="371">371</span>
<span id="372">372</span>
<span id="373">373</span>
<span id="374">374</span>
<span id="375">375</span>
<span id="376">376</span>
<span id="377">377</span>
<span id="378">378</span>
<span id="379">379</span>
<span id="380">380</span>
<span id="381">381</span>
<span id="382">382</span>
<span id="383">383</span>
<span id="384">384</span>
<span id="385">385</span>
<span id="386">386</span>
<span id="387">387</span>
<span id="388">388</span>
<span id="389">389</span>
<span id="390">390</span>
<span id="391">391</span>
<span id="392">392</span>
<span id="393">393</span>
<span id="394">394</span>
<span id="395">395</span>
<span id="396">396</span>
<span id="397">397</span>
<span id="398">398</span>
<span id="399">399</span>
<span id="400">400</span>
<span id="401">401</span>
<span id="402">402</span>
<span id="403">403</span>
<span id="404">404</span>
<span id="405">405</span>
<span id="406">406</span>
<span id="407">407</span>
<span id="408">408</span>
<span id="409">409</span>
<span id="410">410</span>
<span id="411">411</span>
<span id="412">412</span>
<span id="413">413</span>
<span id="414">414</span>
<span id="415">415</span>
<span id="416">416</span>
<span id="417">417</span>
<span id="418">418</span>
<span id="419">419</span>
<span id="420">420</span>
<span id="421">421</span>
<span id="422">422</span>
<span id="423">423</span>
<span id="424">424</span>
<span id="425">425</span>
<span id="426">426</span>
<span id="427">427</span>
<span id="428">428</span>
<span id="429">429</span>
<span id="430">430</span>
<span id="431">431</span>
<span id="432">432</span>
<span id="433">433</span>
<span id="434">434</span>
<span id="435">435</span>
<span id="436">436</span>
<span id="437">437</span>
<span id="438">438</span>
<span id="439">439</span>
<span id="440">440</span>
<span id="441">441</span>
<span id="442">442</span>
<span id="443">443</span>
<span id="444">444</span>
<span id="445">445</span>
<span id="446">446</span>
<span id="447">447</span>
<span id="448">448</span>
<span id="449">449</span>
<span id="450">450</span>
<span id="451">451</span>
<span id="452">452</span>
<span id="453">453</span>
<span id="454">454</span>
<span id="455">455</span>
<span id="456">456</span>
<span id="457">457</span>
<span id="458">458</span>
<span id="459">459</span>
<span id="460">460</span>
<span id="461">461</span>
<span id="462">462</span>
</pre><pre class="rust"><code><span class="doccomment">//! Support for symbolication using the `gimli` crate on crates.io</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! This is the default symbolication implementation for Rust.</span>

<span class="kw">use</span> <span class="ident"><span class="self">self</span>::gimli::read::EndianSlice</span>;
<span class="kw">use</span> <span class="ident"><span class="self">self</span>::gimli::NativeEndian</span> <span class="kw">as</span> <span class="ident">Endian</span>;
<span class="kw">use</span> <span class="ident"><span class="self">self</span>::mmap::Mmap</span>;
<span class="kw">use</span> <span class="ident"><span class="self">self</span>::stash::Stash</span>;
<span class="kw">use</span> <span class="ident"><span class="kw">super</span>::BytesOrWideString</span>;
<span class="kw">use</span> <span class="ident"><span class="kw">super</span>::ResolveWhat</span>;
<span class="kw">use</span> <span class="ident"><span class="kw">super</span>::SymbolName</span>;
<span class="kw">use</span> <span class="ident">addr2line::gimli</span>;
<span class="kw">use</span> <span class="ident">core::convert::TryInto</span>;
<span class="kw">use</span> <span class="ident">core::mem</span>;
<span class="kw">use</span> <span class="ident">core::u32</span>;
<span class="kw">use</span> <span class="ident">libc::c_void</span>;
<span class="kw">use</span> <span class="ident">mystd::ffi::OsString</span>;
<span class="kw">use</span> <span class="ident">mystd::fs::File</span>;
<span class="kw">use</span> <span class="ident">mystd::path::Path</span>;
<span class="kw">use</span> <span class="ident">mystd::prelude::v1</span>::<span class="kw-2">*</span>;

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">backtrace_in_libstd</span>)]</span>
<span class="kw">mod</span> <span class="ident">mystd</span> {
    <span class="kw">pub</span> <span class="kw">use</span> <span class="kw">crate</span>::<span class="kw-2">*</span>;
}
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">not</span>(<span class="ident">backtrace_in_libstd</span>))]</span>
<span class="kw">extern</span> <span class="kw">crate</span> <span class="ident">std</span> <span class="kw">as</span> <span class="ident">mystd</span>;

<span class="macro">cfg_if::cfg_if!</span> {
    <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">windows</span>)]</span> {
        <span class="attribute">#[<span class="ident">path</span> <span class="op">=</span> <span class="string">&quot;gimli/mmap_windows.rs&quot;</span>]</span>
        <span class="kw">mod</span> <span class="ident">mmap</span>;
    } <span class="kw">else</span> <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">any</span>(
        <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;android&quot;</span>,
        <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;freebsd&quot;</span>,
        <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;fuchsia&quot;</span>,
        <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;haiku&quot;</span>,
        <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;ios&quot;</span>,
        <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;linux&quot;</span>,
        <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;macos&quot;</span>,
        <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;openbsd&quot;</span>,
        <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;solaris&quot;</span>,
        <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;illumos&quot;</span>,
    ))]</span> {
        <span class="attribute">#[<span class="ident">path</span> <span class="op">=</span> <span class="string">&quot;gimli/mmap_unix.rs&quot;</span>]</span>
        <span class="kw">mod</span> <span class="ident">mmap</span>;
    } <span class="kw">else</span> {
        <span class="attribute">#[<span class="ident">path</span> <span class="op">=</span> <span class="string">&quot;gimli/mmap_fake.rs&quot;</span>]</span>
        <span class="kw">mod</span> <span class="ident">mmap</span>;
    }
}

<span class="kw">mod</span> <span class="ident">stash</span>;

<span class="kw">const</span> <span class="ident">MAPPINGS_CACHE_SIZE</span>: <span class="ident">usize</span> <span class="op">=</span> <span class="number">4</span>;

<span class="kw">struct</span> <span class="ident">Mapping</span> {
    <span class="comment">// &#39;static lifetime is a lie to hack around lack of support for self-referential structs.</span>
    <span class="ident">cx</span>: <span class="ident">Context</span><span class="op">&lt;</span><span class="lifetime">&#39;static</span><span class="op">&gt;</span>,
    <span class="ident">_map</span>: <span class="ident">Mmap</span>,
    <span class="ident">_stash</span>: <span class="ident">Stash</span>,
}

<span class="kw">enum</span> <span class="ident">Either</span><span class="op">&lt;</span><span class="ident">A</span>, <span class="ident">B</span><span class="op">&gt;</span> {
    <span class="attribute">#[<span class="ident">allow</span>(<span class="ident">dead_code</span>)]</span>
    <span class="ident">A</span>(<span class="ident">A</span>),
    <span class="ident">B</span>(<span class="ident">B</span>),
}

<span class="kw">impl</span> <span class="ident">Mapping</span> {
    <span class="doccomment">/// Creates a `Mapping` by ensuring that the `data` specified is used to</span>
    <span class="doccomment">/// create a `Context` and it can only borrow from that or the `Stash` of</span>
    <span class="doccomment">/// decompressed sections or auxiliary data.</span>
    <span class="kw">fn</span> <span class="ident">mk</span><span class="op">&lt;</span><span class="ident">F</span><span class="op">&gt;</span>(<span class="ident">data</span>: <span class="ident">Mmap</span>, <span class="ident">mk</span>: <span class="ident">F</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">Mapping</span><span class="op">&gt;</span>
    <span class="kw">where</span>
        <span class="ident">F</span>: <span class="kw">for</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> <span class="ident">FnOnce</span>(<span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> [<span class="ident">u8</span>], <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">Stash</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">Context</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span><span class="op">&gt;</span>,
    {
        <span class="ident">Mapping::mk_or_other</span>(<span class="ident">data</span>, <span class="kw">move</span> <span class="op">|</span><span class="ident">data</span>, <span class="ident">stash</span><span class="op">|</span> {
            <span class="kw">let</span> <span class="ident">cx</span> <span class="op">=</span> <span class="ident">mk</span>(<span class="ident">data</span>, <span class="ident">stash</span>)<span class="question-mark">?</span>;
            <span class="prelude-val">Some</span>(<span class="ident">Either::B</span>(<span class="ident">cx</span>))
        })
    }

    <span class="doccomment">/// Creates a `Mapping` from `data`, or if the closure decides to, returns a</span>
    <span class="doccomment">/// different mapping.</span>
    <span class="kw">fn</span> <span class="ident">mk_or_other</span><span class="op">&lt;</span><span class="ident">F</span><span class="op">&gt;</span>(<span class="ident">data</span>: <span class="ident">Mmap</span>, <span class="ident">mk</span>: <span class="ident">F</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">Mapping</span><span class="op">&gt;</span>
    <span class="kw">where</span>
        <span class="ident">F</span>: <span class="kw">for</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> <span class="ident">FnOnce</span>(<span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> [<span class="ident">u8</span>], <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">Stash</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">Either</span><span class="op">&lt;</span><span class="ident">Mapping</span>, <span class="ident">Context</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span><span class="op">&gt;</span><span class="op">&gt;</span>,
    {
        <span class="kw">let</span> <span class="ident">stash</span> <span class="op">=</span> <span class="ident">Stash::new</span>();
        <span class="kw">let</span> <span class="ident">cx</span> <span class="op">=</span> <span class="kw">match</span> <span class="ident">mk</span>(<span class="kw-2">&amp;</span><span class="ident">data</span>, <span class="kw-2">&amp;</span><span class="ident">stash</span>)<span class="question-mark">?</span> {
            <span class="ident">Either::A</span>(<span class="ident">mapping</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="kw">return</span> <span class="prelude-val">Some</span>(<span class="ident">mapping</span>),
            <span class="ident">Either::B</span>(<span class="ident">cx</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">cx</span>,
        };
        <span class="prelude-val">Some</span>(<span class="ident">Mapping</span> {
            <span class="comment">// Convert to &#39;static lifetimes since the symbols should</span>
            <span class="comment">// only borrow `map` and `stash` and we&#39;re preserving them below.</span>
            <span class="ident">cx</span>: <span class="kw">unsafe</span> { <span class="ident">core::mem::transmute</span>::<span class="op">&lt;</span><span class="ident">Context</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span><span class="op">&gt;</span>, <span class="ident">Context</span><span class="op">&lt;</span><span class="lifetime">&#39;static</span><span class="op">&gt;</span><span class="op">&gt;</span>(<span class="ident">cx</span>) },
            <span class="ident">_map</span>: <span class="ident">data</span>,
            <span class="ident">_stash</span>: <span class="ident">stash</span>,
        })
    }
}

<span class="kw">struct</span> <span class="ident">Context</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {
    <span class="ident">dwarf</span>: <span class="ident">addr2line::Context</span><span class="op">&lt;</span><span class="ident">EndianSlice</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span>, <span class="ident">Endian</span><span class="op">&gt;</span><span class="op">&gt;</span>,
    <span class="ident">object</span>: <span class="ident">Object</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span>,
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span> <span class="ident">Context</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span> {
    <span class="kw">fn</span> <span class="ident">new</span>(
        <span class="ident">stash</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;data</span> <span class="ident">Stash</span>,
        <span class="ident">object</span>: <span class="ident">Object</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span>,
        <span class="ident">sup</span>: <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">Object</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span><span class="op">&gt;</span>,
    ) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">Context</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span><span class="op">&gt;</span> {
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">sections</span> <span class="op">=</span> <span class="ident">gimli::Dwarf::load</span>(<span class="op">|</span><span class="ident">id</span><span class="op">|</span> <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="kw">_</span>, ()<span class="op">&gt;</span> {
            <span class="kw">let</span> <span class="ident">data</span> <span class="op">=</span> <span class="ident">object</span>.<span class="ident">section</span>(<span class="ident">stash</span>, <span class="ident">id</span>.<span class="ident">name</span>()).<span class="ident">unwrap_or</span>(<span class="kw-2">&amp;</span>[]);
            <span class="prelude-val">Ok</span>(<span class="ident">EndianSlice::new</span>(<span class="ident">data</span>, <span class="ident">Endian</span>))
        })
        .<span class="ident">ok</span>()<span class="question-mark">?</span>;

        <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="ident">sup</span>) <span class="op">=</span> <span class="ident">sup</span> {
            <span class="ident">sections</span>
                .<span class="ident">load_sup</span>(<span class="op">|</span><span class="ident">id</span><span class="op">|</span> <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="kw">_</span>, ()<span class="op">&gt;</span> {
                    <span class="kw">let</span> <span class="ident">data</span> <span class="op">=</span> <span class="ident">sup</span>.<span class="ident">section</span>(<span class="ident">stash</span>, <span class="ident">id</span>.<span class="ident">name</span>()).<span class="ident">unwrap_or</span>(<span class="kw-2">&amp;</span>[]);
                    <span class="prelude-val">Ok</span>(<span class="ident">EndianSlice::new</span>(<span class="ident">data</span>, <span class="ident">Endian</span>))
                })
                .<span class="ident">ok</span>()<span class="question-mark">?</span>;
        }
        <span class="kw">let</span> <span class="ident">dwarf</span> <span class="op">=</span> <span class="ident">addr2line::Context::from_dwarf</span>(<span class="ident">sections</span>).<span class="ident">ok</span>()<span class="question-mark">?</span>;

        <span class="prelude-val">Some</span>(<span class="ident">Context</span> { <span class="ident">dwarf</span>, <span class="ident">object</span> })
    }
}

<span class="kw">fn</span> <span class="ident">mmap</span>(<span class="ident">path</span>: <span class="kw-2">&amp;</span><span class="ident">Path</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">Mmap</span><span class="op">&gt;</span> {
    <span class="kw">let</span> <span class="ident">file</span> <span class="op">=</span> <span class="ident">File::open</span>(<span class="ident">path</span>).<span class="ident">ok</span>()<span class="question-mark">?</span>;
    <span class="kw">let</span> <span class="ident">len</span> <span class="op">=</span> <span class="ident">file</span>.<span class="ident">metadata</span>().<span class="ident">ok</span>()<span class="question-mark">?</span>.<span class="ident">len</span>().<span class="ident">try_into</span>().<span class="ident">ok</span>()<span class="question-mark">?</span>;
    <span class="kw">unsafe</span> { <span class="ident">Mmap::map</span>(<span class="kw-2">&amp;</span><span class="ident">file</span>, <span class="ident">len</span>) }
}

<span class="macro">cfg_if::cfg_if!</span> {
    <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">windows</span>)]</span> {
        <span class="kw">mod</span> <span class="ident">coff</span>;
        <span class="kw">use</span> <span class="ident"><span class="self">self</span>::coff::Object</span>;
    } <span class="kw">else</span> <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">any</span>(
        <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;macos&quot;</span>,
        <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;ios&quot;</span>,
        <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;tvos&quot;</span>,
        <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;watchos&quot;</span>,
    ))]</span> {
        <span class="kw">mod</span> <span class="ident">macho</span>;
        <span class="kw">use</span> <span class="ident"><span class="self">self</span>::macho::Object</span>;
    } <span class="kw">else</span> {
        <span class="kw">mod</span> <span class="ident">elf</span>;
        <span class="kw">use</span> <span class="ident"><span class="self">self</span>::elf::Object</span>;
    }
}

<span class="macro">cfg_if::cfg_if!</span> {
    <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">windows</span>)]</span> {
        <span class="kw">mod</span> <span class="ident">libs_windows</span>;
        <span class="kw">use</span> <span class="ident">libs_windows::native_libraries</span>;
    } <span class="kw">else</span> <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">any</span>(
        <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;macos&quot;</span>,
        <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;ios&quot;</span>,
        <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;tvos&quot;</span>,
        <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;watchos&quot;</span>,
    ))]</span> {
        <span class="kw">mod</span> <span class="ident">libs_macos</span>;
        <span class="kw">use</span> <span class="ident">libs_macos::native_libraries</span>;
    } <span class="kw">else</span> <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;illumos&quot;</span>)]</span> {
        <span class="kw">mod</span> <span class="ident">libs_illumos</span>;
        <span class="kw">use</span> <span class="ident">libs_illumos::native_libraries</span>;
    } <span class="kw">else</span> <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">all</span>(
        <span class="ident">any</span>(
            <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;linux&quot;</span>,
            <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;fuchsia&quot;</span>,
            <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;freebsd&quot;</span>,
            <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;openbsd&quot;</span>,
            <span class="ident">all</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;android&quot;</span>, <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;dl_iterate_phdr&quot;</span>),
        ),
        <span class="ident">not</span>(<span class="ident">target_env</span> <span class="op">=</span> <span class="string">&quot;uclibc&quot;</span>),
    ))]</span> {
        <span class="kw">mod</span> <span class="ident">libs_dl_iterate_phdr</span>;
        <span class="kw">use</span> <span class="ident">libs_dl_iterate_phdr::native_libraries</span>;
    } <span class="kw">else</span> <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">target_env</span> <span class="op">=</span> <span class="string">&quot;libnx&quot;</span>)]</span> {
        <span class="kw">mod</span> <span class="ident">libs_libnx</span>;
        <span class="kw">use</span> <span class="ident">libs_libnx::native_libraries</span>;
    } <span class="kw">else</span> <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;haiku&quot;</span>)]</span> {
        <span class="kw">mod</span> <span class="ident">libs_haiku</span>;
        <span class="kw">use</span> <span class="ident">libs_haiku::native_libraries</span>;
    } <span class="kw">else</span> {
        <span class="comment">// Everything else should doesn&#39;t know how to load native libraries.</span>
        <span class="kw">fn</span> <span class="ident">native_libraries</span>() <span class="op">-</span><span class="op">&gt;</span> <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">Library</span><span class="op">&gt;</span> {
            <span class="ident">Vec::new</span>()
        }
    }
}

<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Default</span>)]</span>
<span class="kw">struct</span> <span class="ident">Cache</span> {
    <span class="doccomment">/// All known shared libraries that have been loaded.</span>
    <span class="ident">libraries</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">Library</span><span class="op">&gt;</span>,

    <span class="doccomment">/// Mappings cache where we retain parsed dwarf information.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This list has a fixed capacity for its entire lifetime which never</span>
    <span class="doccomment">/// increases. The `usize` element of each pair is an index into `libraries`</span>
    <span class="doccomment">/// above where `usize::max_value()` represents the current executable. The</span>
    <span class="doccomment">/// `Mapping` is corresponding parsed dwarf information.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Note that this is basically an LRU cache and we&#39;ll be shifting things</span>
    <span class="doccomment">/// around in here as we symbolize addresses.</span>
    <span class="ident">mappings</span>: <span class="ident">Vec</span><span class="op">&lt;</span>(<span class="ident">usize</span>, <span class="ident">Mapping</span>)<span class="op">&gt;</span>,
}

<span class="kw">struct</span> <span class="ident">Library</span> {
    <span class="ident">name</span>: <span class="ident">OsString</span>,
    <span class="doccomment">/// Segments of this library loaded into memory, and where they&#39;re loaded.</span>
    <span class="ident">segments</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">LibrarySegment</span><span class="op">&gt;</span>,
    <span class="doccomment">/// The &quot;bias&quot; of this library, typically where it&#39;s loaded into memory.</span>
    <span class="doccomment">/// This value is added to each segment&#39;s stated address to get the actual</span>
    <span class="doccomment">/// virtual memory address that the segment is loaded into. Additionally</span>
    <span class="doccomment">/// this bias is subtracted from real virtual memory addresses to index into</span>
    <span class="doccomment">/// debuginfo and the symbol table.</span>
    <span class="ident">bias</span>: <span class="ident">usize</span>,
}

<span class="kw">struct</span> <span class="ident">LibrarySegment</span> {
    <span class="doccomment">/// The stated address of this segment in the object file. This is not</span>
    <span class="doccomment">/// actually where the segment is loaded, but rather this address plus the</span>
    <span class="doccomment">/// containing library&#39;s `bias` is where to find it.</span>
    <span class="ident">stated_virtual_memory_address</span>: <span class="ident">usize</span>,
    <span class="doccomment">/// The size of this segment in memory.</span>
    <span class="ident">len</span>: <span class="ident">usize</span>,
}

<span class="comment">// unsafe because this is required to be externally synchronized</span>
<span class="kw">pub</span> <span class="kw">unsafe</span> <span class="kw">fn</span> <span class="ident">clear_symbol_cache</span>() {
    <span class="ident">Cache::with_global</span>(<span class="op">|</span><span class="ident">cache</span><span class="op">|</span> <span class="ident">cache</span>.<span class="ident">mappings</span>.<span class="ident">clear</span>());
}

<span class="kw">impl</span> <span class="ident">Cache</span> {
    <span class="kw">fn</span> <span class="ident">new</span>() <span class="op">-</span><span class="op">&gt;</span> <span class="ident">Cache</span> {
        <span class="ident">Cache</span> {
            <span class="ident">mappings</span>: <span class="ident">Vec::with_capacity</span>(<span class="ident">MAPPINGS_CACHE_SIZE</span>),
            <span class="ident">libraries</span>: <span class="ident">native_libraries</span>(),
        }
    }

    <span class="comment">// unsafe because this is required to be externally synchronized</span>
    <span class="kw">unsafe</span> <span class="kw">fn</span> <span class="ident">with_global</span>(<span class="ident">f</span>: <span class="kw">impl</span> <span class="ident">FnOnce</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">Self</span>)) {
        <span class="comment">// A very small, very simple LRU cache for debug info mappings.</span>
        <span class="comment">//</span>
        <span class="comment">// The hit rate should be very high, since the typical stack doesn&#39;t cross</span>
        <span class="comment">// between many shared libraries.</span>
        <span class="comment">//</span>
        <span class="comment">// The `addr2line::Context` structures are pretty expensive to create. Its</span>
        <span class="comment">// cost is expected to be amortized by subsequent `locate` queries, which</span>
        <span class="comment">// leverage the structures built when constructing `addr2line::Context`s to</span>
        <span class="comment">// get nice speedups. If we didn&#39;t have this cache, that amortization would</span>
        <span class="comment">// never happen, and symbolicating backtraces would be ssssllllooooowwww.</span>
        <span class="kw">static</span> <span class="kw-2">mut</span> <span class="ident">MAPPINGS_CACHE</span>: <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">Cache</span><span class="op">&gt;</span> <span class="op">=</span> <span class="prelude-val">None</span>;

        <span class="ident">f</span>(<span class="ident">MAPPINGS_CACHE</span>.<span class="ident">get_or_insert_with</span>(<span class="op">|</span><span class="op">|</span> <span class="ident">Cache::new</span>()))
    }

    <span class="kw">fn</span> <span class="ident">avma_to_svma</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">addr</span>: <span class="kw-2">*</span><span class="kw">const</span> <span class="ident">u8</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Option</span><span class="op">&lt;</span>(<span class="ident">usize</span>, <span class="kw-2">*</span><span class="kw">const</span> <span class="ident">u8</span>)<span class="op">&gt;</span> {
        <span class="self">self</span>.<span class="ident">libraries</span>
            .<span class="ident">iter</span>()
            .<span class="ident">enumerate</span>()
            .<span class="ident">filter_map</span>(<span class="op">|</span>(<span class="ident">i</span>, <span class="ident">lib</span>)<span class="op">|</span> {
                <span class="comment">// First up, test if this `lib` has any segment containing the</span>
                <span class="comment">// `addr` (handling relocation). If this check passes then we</span>
                <span class="comment">// can continue below and actually translate the address.</span>
                <span class="comment">//</span>
                <span class="comment">// Note that we&#39;re using `wrapping_add` here to avoid overflow</span>
                <span class="comment">// checks. It&#39;s been seen in the wild that the SVMA + bias</span>
                <span class="comment">// computation overflows. It seems a bit odd that would happen</span>
                <span class="comment">// but there&#39;s not a huge amount we can do about it other than</span>
                <span class="comment">// probably just ignore those segments since they&#39;re likely</span>
                <span class="comment">// pointing off into space. This originally came up in</span>
                <span class="comment">// rust-lang/backtrace-rs#329.</span>
                <span class="kw">if</span> <span class="op">!</span><span class="ident">lib</span>.<span class="ident">segments</span>.<span class="ident">iter</span>().<span class="ident">any</span>(<span class="op">|</span><span class="ident">s</span><span class="op">|</span> {
                    <span class="kw">let</span> <span class="ident">svma</span> <span class="op">=</span> <span class="ident">s</span>.<span class="ident">stated_virtual_memory_address</span>;
                    <span class="kw">let</span> <span class="ident">start</span> <span class="op">=</span> <span class="ident">svma</span>.<span class="ident">wrapping_add</span>(<span class="ident">lib</span>.<span class="ident">bias</span>);
                    <span class="kw">let</span> <span class="ident">end</span> <span class="op">=</span> <span class="ident">start</span>.<span class="ident">wrapping_add</span>(<span class="ident">s</span>.<span class="ident">len</span>);
                    <span class="kw">let</span> <span class="ident">address</span> <span class="op">=</span> <span class="ident">addr</span> <span class="kw">as</span> <span class="ident">usize</span>;
                    <span class="ident">start</span> <span class="op">&lt;</span><span class="op">=</span> <span class="ident">address</span> <span class="op">&amp;&amp;</span> <span class="ident">address</span> <span class="op">&lt;</span> <span class="ident">end</span>
                }) {
                    <span class="kw">return</span> <span class="prelude-val">None</span>;
                }

                <span class="comment">// Now that we know `lib` contains `addr`, we can offset with</span>
                <span class="comment">// the bias to find the stated virtual memory address.</span>
                <span class="kw">let</span> <span class="ident">svma</span> <span class="op">=</span> (<span class="ident">addr</span> <span class="kw">as</span> <span class="ident">usize</span>).<span class="ident">wrapping_sub</span>(<span class="ident">lib</span>.<span class="ident">bias</span>);
                <span class="prelude-val">Some</span>((<span class="ident">i</span>, <span class="ident">svma</span> <span class="kw">as</span> <span class="kw-2">*</span><span class="kw">const</span> <span class="ident">u8</span>))
            })
            .<span class="ident">next</span>()
    }

    <span class="kw">fn</span> <span class="ident">mapping_for_lib</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span>(<span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="kw-2">mut</span> <span class="self">self</span>, <span class="ident">lib</span>: <span class="ident">usize</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="kw-2">mut</span> <span class="ident">Context</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span><span class="op">&gt;</span> {
        <span class="kw">let</span> <span class="ident">idx</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">mappings</span>.<span class="ident">iter</span>().<span class="ident">position</span>(<span class="op">|</span>(<span class="ident">idx</span>, <span class="kw">_</span>)<span class="op">|</span> <span class="kw-2">*</span><span class="ident">idx</span> <span class="op">=</span><span class="op">=</span> <span class="ident">lib</span>);

        <span class="comment">// Invariant: after this conditional completes without early returning</span>
        <span class="comment">// from an error, the cache entry for this path is at index 0.</span>

        <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="ident">idx</span>) <span class="op">=</span> <span class="ident">idx</span> {
            <span class="comment">// When the mapping is already in the cache, move it to the front.</span>
            <span class="kw">if</span> <span class="ident">idx</span> <span class="op">!</span><span class="op">=</span> <span class="number">0</span> {
                <span class="kw">let</span> <span class="ident">entry</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">mappings</span>.<span class="ident">remove</span>(<span class="ident">idx</span>);
                <span class="self">self</span>.<span class="ident">mappings</span>.<span class="ident">insert</span>(<span class="number">0</span>, <span class="ident">entry</span>);
            }
        } <span class="kw">else</span> {
            <span class="comment">// When the mapping is not in the cache, create a new mapping,</span>
            <span class="comment">// insert it into the front of the cache, and evict the oldest cache</span>
            <span class="comment">// entry if necessary.</span>
            <span class="kw">let</span> <span class="ident">name</span> <span class="op">=</span> <span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">libraries</span>[<span class="ident">lib</span>].<span class="ident">name</span>;
            <span class="kw">let</span> <span class="ident">mapping</span> <span class="op">=</span> <span class="ident">Mapping::new</span>(<span class="ident">name</span>.<span class="ident">as_ref</span>())<span class="question-mark">?</span>;

            <span class="kw">if</span> <span class="self">self</span>.<span class="ident">mappings</span>.<span class="ident">len</span>() <span class="op">=</span><span class="op">=</span> <span class="ident">MAPPINGS_CACHE_SIZE</span> {
                <span class="self">self</span>.<span class="ident">mappings</span>.<span class="ident">pop</span>();
            }

            <span class="self">self</span>.<span class="ident">mappings</span>.<span class="ident">insert</span>(<span class="number">0</span>, (<span class="ident">lib</span>, <span class="ident">mapping</span>));
        }

        <span class="kw">let</span> <span class="ident">cx</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="kw-2">mut</span> <span class="ident">Context</span><span class="op">&lt;</span><span class="lifetime">&#39;static</span><span class="op">&gt;</span> <span class="op">=</span> <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>.<span class="ident">mappings</span>[<span class="number">0</span>].<span class="number">1</span>.<span class="ident">cx</span>;
        <span class="comment">// don&#39;t leak the `&#39;static` lifetime, make sure it&#39;s scoped to just</span>
        <span class="comment">// ourselves</span>
        <span class="prelude-val">Some</span>(<span class="kw">unsafe</span> { <span class="ident">mem::transmute</span>::<span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="kw-2">mut</span> <span class="ident">Context</span><span class="op">&lt;</span><span class="lifetime">&#39;static</span><span class="op">&gt;</span>, <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="kw-2">mut</span> <span class="ident">Context</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span><span class="op">&gt;</span>(<span class="ident">cx</span>) })
    }
}

<span class="kw">pub</span> <span class="kw">unsafe</span> <span class="kw">fn</span> <span class="ident">resolve</span>(<span class="ident">what</span>: <span class="ident">ResolveWhat</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span><span class="op">&gt;</span>, <span class="ident">cb</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="kw">dyn</span> <span class="ident">FnMut</span>(<span class="kw-2">&amp;</span><span class="ident"><span class="kw">super</span>::Symbol</span>)) {
    <span class="kw">let</span> <span class="ident">addr</span> <span class="op">=</span> <span class="ident">what</span>.<span class="ident">address_or_ip</span>();
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">call</span> <span class="op">=</span> <span class="op">|</span><span class="ident">sym</span>: <span class="ident">Symbol</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span><span class="op">&gt;</span><span class="op">|</span> {
        <span class="comment">// Extend the lifetime of `sym` to `&#39;static` since we are unfortunately</span>
        <span class="comment">// required to here, but it&#39;s only ever going out as a reference so no</span>
        <span class="comment">// reference to it should be persisted beyond this frame anyway.</span>
        <span class="kw">let</span> <span class="ident">sym</span> <span class="op">=</span> <span class="ident">mem::transmute</span>::<span class="op">&lt;</span><span class="ident">Symbol</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span><span class="op">&gt;</span>, <span class="ident">Symbol</span><span class="op">&lt;</span><span class="lifetime">&#39;static</span><span class="op">&gt;</span><span class="op">&gt;</span>(<span class="ident">sym</span>);
        (<span class="ident">cb</span>)(<span class="kw-2">&amp;</span><span class="ident"><span class="kw">super</span>::Symbol</span> { <span class="ident">inner</span>: <span class="ident">sym</span> });
    };

    <span class="ident">Cache::with_global</span>(<span class="op">|</span><span class="ident">cache</span><span class="op">|</span> {
        <span class="kw">let</span> (<span class="ident">lib</span>, <span class="ident">addr</span>) <span class="op">=</span> <span class="kw">match</span> <span class="ident">cache</span>.<span class="ident">avma_to_svma</span>(<span class="ident">addr</span> <span class="kw">as</span> <span class="kw-2">*</span><span class="kw">const</span> <span class="ident">u8</span>) {
            <span class="prelude-val">Some</span>(<span class="ident">pair</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">pair</span>,
            <span class="prelude-val">None</span> <span class="op">=</span><span class="op">&gt;</span> <span class="kw">return</span>,
        };

        <span class="comment">// Finally, get a cached mapping or create a new mapping for this file, and</span>
        <span class="comment">// evaluate the DWARF info to find the file/line/name for this address.</span>
        <span class="kw">let</span> <span class="ident">cx</span> <span class="op">=</span> <span class="kw">match</span> <span class="ident">cache</span>.<span class="ident">mapping_for_lib</span>(<span class="ident">lib</span>) {
            <span class="prelude-val">Some</span>(<span class="ident">cx</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">cx</span>,
            <span class="prelude-val">None</span> <span class="op">=</span><span class="op">&gt;</span> <span class="kw">return</span>,
        };
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">any_frames</span> <span class="op">=</span> <span class="bool-val">false</span>;
        <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Ok</span>(<span class="kw-2">mut</span> <span class="ident">frames</span>) <span class="op">=</span> <span class="ident">cx</span>.<span class="ident">dwarf</span>.<span class="ident">find_frames</span>(<span class="ident">addr</span> <span class="kw">as</span> <span class="ident">u64</span>) {
            <span class="kw">while</span> <span class="kw">let</span> <span class="prelude-val">Ok</span>(<span class="prelude-val">Some</span>(<span class="ident">frame</span>)) <span class="op">=</span> <span class="ident">frames</span>.<span class="ident">next</span>() {
                <span class="ident">any_frames</span> <span class="op">=</span> <span class="bool-val">true</span>;
                <span class="kw">let</span> <span class="ident">name</span> <span class="op">=</span> <span class="kw">match</span> <span class="ident">frame</span>.<span class="ident">function</span> {
                    <span class="prelude-val">Some</span>(<span class="ident">f</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="prelude-val">Some</span>(<span class="ident">f</span>.<span class="ident">name</span>.<span class="ident">slice</span>()),
                    <span class="prelude-val">None</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">cx</span>.<span class="ident">object</span>.<span class="ident">search_symtab</span>(<span class="ident">addr</span> <span class="kw">as</span> <span class="ident">u64</span>),
                };
                <span class="ident">call</span>(<span class="ident">Symbol::Frame</span> {
                    <span class="ident">addr</span>: <span class="ident">addr</span> <span class="kw">as</span> <span class="kw-2">*</span><span class="kw-2">mut</span> <span class="ident">c_void</span>,
                    <span class="ident">location</span>: <span class="ident">frame</span>.<span class="ident">location</span>,
                    <span class="ident">name</span>,
                });
            }
        }
        <span class="kw">if</span> <span class="op">!</span><span class="ident">any_frames</span> {
            <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Some</span>((<span class="ident">object_cx</span>, <span class="ident">object_addr</span>)) <span class="op">=</span> <span class="ident">cx</span>.<span class="ident">object</span>.<span class="ident">search_object_map</span>(<span class="ident">addr</span> <span class="kw">as</span> <span class="ident">u64</span>) {
                <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Ok</span>(<span class="kw-2">mut</span> <span class="ident">frames</span>) <span class="op">=</span> <span class="ident">object_cx</span>.<span class="ident">dwarf</span>.<span class="ident">find_frames</span>(<span class="ident">object_addr</span>) {
                    <span class="kw">while</span> <span class="kw">let</span> <span class="prelude-val">Ok</span>(<span class="prelude-val">Some</span>(<span class="ident">frame</span>)) <span class="op">=</span> <span class="ident">frames</span>.<span class="ident">next</span>() {
                        <span class="ident">any_frames</span> <span class="op">=</span> <span class="bool-val">true</span>;
                        <span class="ident">call</span>(<span class="ident">Symbol::Frame</span> {
                            <span class="ident">addr</span>: <span class="ident">addr</span> <span class="kw">as</span> <span class="kw-2">*</span><span class="kw-2">mut</span> <span class="ident">c_void</span>,
                            <span class="ident">location</span>: <span class="ident">frame</span>.<span class="ident">location</span>,
                            <span class="ident">name</span>: <span class="ident">frame</span>.<span class="ident">function</span>.<span class="ident">map</span>(<span class="op">|</span><span class="ident">f</span><span class="op">|</span> <span class="ident">f</span>.<span class="ident">name</span>.<span class="ident">slice</span>()),
                        });
                    }
                }
            }
        }
        <span class="kw">if</span> <span class="op">!</span><span class="ident">any_frames</span> {
            <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="ident">name</span>) <span class="op">=</span> <span class="ident">cx</span>.<span class="ident">object</span>.<span class="ident">search_symtab</span>(<span class="ident">addr</span> <span class="kw">as</span> <span class="ident">u64</span>) {
                <span class="ident">call</span>(<span class="ident">Symbol::Symtab</span> {
                    <span class="ident">addr</span>: <span class="ident">addr</span> <span class="kw">as</span> <span class="kw-2">*</span><span class="kw-2">mut</span> <span class="ident">c_void</span>,
                    <span class="ident">name</span>,
                });
            }
        }
    });
}

<span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">Symbol</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {
    <span class="doccomment">/// We were able to locate frame information for this symbol, and</span>
    <span class="doccomment">/// `addr2line`&#39;s frame internally has all the nitty gritty details.</span>
    <span class="ident">Frame</span> {
        <span class="ident">addr</span>: <span class="kw-2">*</span><span class="kw-2">mut</span> <span class="ident">c_void</span>,
        <span class="ident">location</span>: <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">addr2line::Location</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span><span class="op">&gt;</span>,
        <span class="ident">name</span>: <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> [<span class="ident">u8</span>]<span class="op">&gt;</span>,
    },
    <span class="doccomment">/// Couldn&#39;t find debug information, but we found it in the symbol table of</span>
    <span class="doccomment">/// the elf executable.</span>
    <span class="ident">Symtab</span> { <span class="ident">addr</span>: <span class="kw-2">*</span><span class="kw-2">mut</span> <span class="ident">c_void</span>, <span class="ident">name</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> [<span class="ident">u8</span>] },
}

<span class="kw">impl</span> <span class="ident">Symbol</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span><span class="op">&gt;</span> {
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">name</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">SymbolName</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span><span class="op">&gt;</span><span class="op">&gt;</span> {
        <span class="kw">match</span> <span class="self">self</span> {
            <span class="ident">Symbol::Frame</span> { <span class="ident">name</span>, .. } <span class="op">=</span><span class="op">&gt;</span> {
                <span class="kw">let</span> <span class="ident">name</span> <span class="op">=</span> <span class="ident">name</span>.<span class="ident">as_ref</span>()<span class="question-mark">?</span>;
                <span class="prelude-val">Some</span>(<span class="ident">SymbolName::new</span>(<span class="ident">name</span>))
            }
            <span class="ident">Symbol::Symtab</span> { <span class="ident">name</span>, .. } <span class="op">=</span><span class="op">&gt;</span> <span class="prelude-val">Some</span>(<span class="ident">SymbolName::new</span>(<span class="ident">name</span>)),
        }
    }

    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">addr</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="kw-2">*</span><span class="kw-2">mut</span> <span class="ident">c_void</span><span class="op">&gt;</span> {
        <span class="kw">match</span> <span class="self">self</span> {
            <span class="ident">Symbol::Frame</span> { <span class="ident">addr</span>, .. } <span class="op">=</span><span class="op">&gt;</span> <span class="prelude-val">Some</span>(<span class="kw-2">*</span><span class="ident">addr</span>),
            <span class="ident">Symbol::Symtab</span> { .. } <span class="op">=</span><span class="op">&gt;</span> <span class="prelude-val">None</span>,
        }
    }

    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">filename_raw</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">BytesOrWideString</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span><span class="op">&gt;</span><span class="op">&gt;</span> {
        <span class="kw">match</span> <span class="self">self</span> {
            <span class="ident">Symbol::Frame</span> { <span class="ident">location</span>, .. } <span class="op">=</span><span class="op">&gt;</span> {
                <span class="kw">let</span> <span class="ident">file</span> <span class="op">=</span> <span class="ident">location</span>.<span class="ident">as_ref</span>()<span class="question-mark">?</span>.<span class="ident">file</span><span class="question-mark">?</span>;
                <span class="prelude-val">Some</span>(<span class="ident">BytesOrWideString::Bytes</span>(<span class="ident">file</span>.<span class="ident">as_bytes</span>()))
            }
            <span class="ident">Symbol::Symtab</span> { .. } <span class="op">=</span><span class="op">&gt;</span> <span class="prelude-val">None</span>,
        }
    }

    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">filename</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="ident">Path</span><span class="op">&gt;</span> {
        <span class="kw">match</span> <span class="self">self</span> {
            <span class="ident">Symbol::Frame</span> { <span class="ident">location</span>, .. } <span class="op">=</span><span class="op">&gt;</span> {
                <span class="kw">let</span> <span class="ident">file</span> <span class="op">=</span> <span class="ident">location</span>.<span class="ident">as_ref</span>()<span class="question-mark">?</span>.<span class="ident">file</span><span class="question-mark">?</span>;
                <span class="prelude-val">Some</span>(<span class="ident">Path::new</span>(<span class="ident">file</span>))
            }
            <span class="ident">Symbol::Symtab</span> { .. } <span class="op">=</span><span class="op">&gt;</span> <span class="prelude-val">None</span>,
        }
    }

    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">lineno</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">u32</span><span class="op">&gt;</span> {
        <span class="kw">match</span> <span class="self">self</span> {
            <span class="ident">Symbol::Frame</span> { <span class="ident">location</span>, .. } <span class="op">=</span><span class="op">&gt;</span> <span class="ident">location</span>.<span class="ident">as_ref</span>()<span class="question-mark">?</span>.<span class="ident">line</span>,
            <span class="ident">Symbol::Symtab</span> { .. } <span class="op">=</span><span class="op">&gt;</span> <span class="prelude-val">None</span>,
        }
    }

    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">colno</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">u32</span><span class="op">&gt;</span> {
        <span class="kw">match</span> <span class="self">self</span> {
            <span class="ident">Symbol::Frame</span> { <span class="ident">location</span>, .. } <span class="op">=</span><span class="op">&gt;</span> <span class="ident">location</span>.<span class="ident">as_ref</span>()<span class="question-mark">?</span>.<span class="ident">column</span>,
            <span class="ident">Symbol::Symtab</span> { .. } <span class="op">=</span><span class="op">&gt;</span> <span class="prelude-val">None</span>,
        }
    }
}
</code></pre></div>
</section><section id="search" class="content hidden"></section><div id="rustdoc-vars" data-root-path="../../../" data-current-crate="backtrace" data-search-index-js="../../../search-index.js" data-search-js="../../../search.js"></div>
    <script src="../../../main.js"></script><script src="../../../source-script.js"></script><script src="../../../source-files.js"></script>
</body></html>